// By jack music,from ucancode software
// You can contact us.
// jack@ucancode.net
// Visit http://www.ucancode.net to download new version.
/********************************************************************/
/////////////////////////////////////////////////////////////////////////////
#if !defined(AFX_BTANGLEWND_H__169A04E0_A8B2_4B3F_AACD_F252CFBC1A5C__INCLUDED_)
#define AFX_BTANGLEWND_H__169A04E0_A8B2_4B3F_AACD_F252CFBC1A5C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// BTAngleWnd.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CBTAngleWnd window

#define EX_WM_EDITCHANGE WM_USER+5

class CBTAngleWnd : public CWnd
{
// Construction
public:
	CBTAngleWnd();

// Attributes
public:

	// Get current angle value.
	double GetAngle();

	// Change current angle value.
	void SetAngle(const double &dAngle, BOOL bRedraw = TRUE);
	
	// Do update state.
	void DoUpdate(BOOL bRedraw = TRUE);

	// Attach current box to a specify wnd.
	void AttachToEditBox(CWnd *pWnd);

	// Convert angle to text.
	TCHAR *GetAngleWindowText(TCHAR *szBuf);

	// Get back color.
	COLORREF GetBackColor() const { return m_crBack; }

	// Change back color.
	void SetBackColor(const COLORREF &cr) { m_crBack= cr; }

	// Fix angle value.
	double FixAngle(const double &angle);

	// Compute angle between two points.
	double ComputeAngle(const CPoint &ptStart, const CPoint &ptEnd);

	// Make it can be selected.
	void TurnOnNow(BOOL bOn);

	// Change angle value.
	void SetAngleValue(const double &dAngle, BOOL bRedraw = TRUE);

	// Update box.
	void UpdateAngleBox(BOOL bRedraw = TRUE);

protected:

	// Update attach edit box.
	void UpdateAttachBox();

	// Draw angle circle.
	void DoDrawAngleCircle(CDC *pDC);

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBTAngleWnd)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBTAngleWnd();

	// Generated message map functions
protected:
	//{{AFX_MSG(CBTAngleWnd)
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnPaint();
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

protected:

	// Point of center.
	CPoint		m_ptCenter;

	// Back color.
	COLORREF	m_crBack;

	// Track mode.
	BOOL		m_bTrack;

	// Drawing dc.
	CDC			m_DrawDC;
	
	// Angle value
	double		m_dAngle;

	// Attach wnd handle.
	CWnd *		m_pAttachWnd;

};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BTANGLEWND_H__169A04E0_A8B2_4B3F_AACD_F252CFBC1A5C__INCLUDED_)
